Option Explicit

Const cAcsMessageConsole = 1
Const cAcsMessageStdOut = 2
Const cAcsMessageDialog = 3
Const cAcsMessageConsoleAndDiarog = 4
Const cAcsMessagePopup = 5

Const cAcsMessageStop = 1
Const cAcsMessageContinue = 0

Const cAcsMessageSkin = "skin.csv"
Const cAcsMessageDefault = "message.csv"

Dim strMsgCode()
Dim strMsgDisp()
Dim strMsgText()
Dim strMsgOption()
Dim strMsgFlag()
Dim lngMsgCount

Dim strACS010I_Text

Dim objFS
Dim objCSV

'-------------------------------------------------------------------------------
'bZ[W\ip^j
'-------------------------------------------------------------------------------
Function sMessage(pMsgID)

    Dim tmpStatus

    tmpStatus = sMessageD(pMsgID, vbNullString)

    sMessage = tmpStatus

End Function

'-------------------------------------------------------------------------------
'bZ[W\
'-------------------------------------------------------------------------------
Function sMessageD(pMsgID, pParm)

    Dim tmpMsgId
    Dim tmpRow
    Dim tmpCode
    Dim tmpDisp
    Dim tmpText
    Dim tmpOption
    Dim tmpFlag
    Dim tmpStatus
    Dim tmpWShell

    tmpStatus = 0

    tmpMsgId = UCase(Trim(pMsgID))

    tmpRow = fGetMessage(tmpMsgId)
    If tmpRow = (-1) Then
       tmpRow = fGetMessage("ACS401E")
       tmpCode = pMsgID
    Else
       tmpCode = strMsgCode(tmpRow)
    End If

    tmpDisp = strMsgDisp(tmpRow)

    tmpText = strMsgText(tmpRow)
    tmpText = Replace(tmpText, vbCrLf, vbNullString)
    tmpText = Replace(tmpText, vbCr, vbNullString)
    tmpText = Replace(tmpText, vbLf, vbNullString)
    tmpText = Replace(tmpText, "%PARM%", pParm)
    tmpText = Replace(tmpText, "%CR%", vbCrLf)

    tmpOption = strMsgOption(tmpRow)
    tmpFlag = strMsgFlag(tmpRow)

    Select Case tmpDisp

           Case cAcsMessageConsole
                WScript.Echo tmpCode & " " & fDateTime & " - " & tmpText

           Case cAcsMessageStdOut
                WScript.StdOut.Write tmpText
                WScript.StdOut.Write vbCr

           Case cAcsMessageDialog
                tmpStatus = MsgBox(tmpText, tmpOption, tmpCode & " ([U: " & strUserName & ")")

           Case cAcsMessageConsoleAndDiarog
                WScript.Echo tmpCode & " " & fDateTime & " - " & tmpText
                tmpStatus = MsgBox(tmpText, tmpOption, tmpCode & " ([U: " & strUserName & ")")

           Case cAcsMessagePopup
                Set tmpWShell = CreateObject("WScript.Shell")
                tmpStatus = tmpWShell.PopUp(tmpText, tmpFlag, tmpCode & " ([U: " & strUserName & ")", tmpOption)
                Set tmpWShell = Nothing

    End Select

    If tmpFlag = cAcsMessageStop Then
       WScript.Quit(0)
    End If

    sMessageD = tmpStatus

End Function

'-------------------------------------------------------------------------------
'Wo͗pbZ[W\
'-------------------------------------------------------------------------------
Function sStdOutMessageD(pMsgID, pParm)

    Dim tmpStatus

    tmpStatus = sMessageD(pMsgID, pParm)

    sStdOutMessageD = tmpStatus

End Function

'-------------------------------------------------------------------------------
'ACS010I(NbNAb)̕\
'-------------------------------------------------------------------------------
Sub sMessageACS010I(pParm)

    WScript.StdOut.Write strACS010I_Text & pParm
    WScript.StdOut.Write vbCr

End Sub

'-------------------------------------------------------------------------------
'bZ[W̌
'-------------------------------------------------------------------------------
Function fGetMessage(pID)

    Dim i

    For i=0 To lngMsgCount
        If strMsgCode(i) = UCase(Trim(pID)) Then
           fGetMessage = i
           Exit Function
        End If
    Next

    fGetMessage = -1

End Function

'-------------------------------------------------------------------------------
'bZ[W`̎擾Ɗ֘A鏉iCj
'-------------------------------------------------------------------------------
Function fMessageRead()

    Set objFS = CreateObject("Scripting.FilesystemObject")
    Set objCSV =CreateObject("ADODB.Connection")

    objCSV.Open "Driver={Microsoft Text Driver (*.txt; *.csv)}; DBQ=" & strScriptPath & "config;"

    lngMsgCount = -1

    Call fReadSkin()

    If fReadMessage() = False Then
       fMessageRead = False
    Else
       'WbZ[W擾
       Call sGetFixedMessage

       fMessageRead = True
    End If

    objCSV.Close

    Set objCSV = Nothing
    Set objFS = Nothing

End Function

'-------------------------------------------------------------------------------
'bZ[W`̎擾iXLj
'-------------------------------------------------------------------------------
Function fReadSkin()

    Dim strSQL
    Dim objRS

    fReadSkin = False

    If objFS.FileExists(strScriptPath & "config\" & cAcsMessageSkin) = False Then
       Exit Function
    End If

    strSQL = "SELECT * FROM " & cAcsMessageSkin
    Set objRS = objCSV.Execute(strSQL)

    Do Until objRS.Eof = True

       lngMsgCount = lngMsgCount + 1
       ReDim Preserve strMsgCode(lngMsgCount)
       ReDim Preserve strMsgDisp(lngMsgCount)
       ReDim Preserve strMsgText(lngMsgCount)
       ReDim Preserve strMsgOption(lngMsgCount)
       ReDim Preserve strMsgFlag(lngMsgCount)

       strMsgCode(lngMsgCount) = objRS("R[h")
       strMsgDisp(lngMsgCount) = objRS("o͐")
       strMsgText(lngMsgCount) = objRS("bZ[W")
       strMsgOption(lngMsgCount) = objRS("IvV")
       strMsgFlag(lngMsgCount) = objRS("I")

       objRS.MoveNext

    Loop

    objRS.Close
    Set objRS = Nothing

    fReadSkin = True

End Function

'-------------------------------------------------------------------------------
'bZ[W`̎擾iWj
'-------------------------------------------------------------------------------
Function fReadMessage()

    Dim strSQL
    Dim objRS

    fReadMessage = False

    If objFS.FileExists(strScriptPath & "config\" & cAcsMessageDefault) = False Then
       Exit Function
    End If

    If objFS.FileExists(strScriptPath & "config\" & cAcsMessageSkin) = True Then
       strSQL = "SELECT A.R[h, A.o͐, A.bZ[W, A.IvV, A.I" _
              & "  FROM " & cAcsMessageDefault & " AS A" _
              & "  LEFT JOIN " & cAcsMessageSkin & " AS B ON A.R[h = B.R[h" _
              & " WHERE B.R[h Is Null"
    Else
       strSQL = "SELECT * FROM " & cAcsMessageDefault
    End If

    Set objRS = objCSV.Execute(strSQL)

    Do Until objRS.Eof = True

       lngMsgCount = lngMsgCount + 1
       ReDim Preserve strMsgCode(lngMsgCount)
       ReDim Preserve strMsgDisp(lngMsgCount)
       ReDim Preserve strMsgText(lngMsgCount)
       ReDim Preserve strMsgOption(lngMsgCount)
       ReDim Preserve strMsgFlag(lngMsgCount)

       strMsgCode(lngMsgCount) = UCase(Trim(objRS("R[h")))
       strMsgDisp(lngMsgCount) = objRS("o͐")
       strMsgText(lngMsgCount) = objRS("bZ[W")
       strMsgOption(lngMsgCount) = objRS("IvV")
       strMsgFlag(lngMsgCount) = objRS("I")

       objRS.MoveNext

    Loop

    objRS.Close
    Set objRS = Nothing

    fReadMessage = True

End Function

'-------------------------------------------------------------------------------
'̃bZ[W̃CfbNX擾
'-------------------------------------------------------------------------------
Sub sGetFixedMessage()

    Dim tmpRow

    'ACS010I
    tmpRow = fGetMessage("ACS010I")

    If tmpRow = (-1) Then
       tmpRow = fGetMessage("ACS401E")
    End If

    strACS010I_Text = strMsgText(tmpRow)
    strACS010I_Text = Replace(strACS010I_Text, vbCrLf, vbNullString)
    strACS010I_Text = Replace(strACS010I_Text, vbCr, vbNullString)
    strACS010I_Text = Replace(strACS010I_Text, vbLf, vbNullString)
    strACS010I_Text = Replace(strACS010I_Text, "%PARM%", vbNullString)
    strACS010I_Text = Replace(strACS010I_Text, "%CR%", vbNullString)

End Sub
